<h1 style="position: relative; line-height: 85%">
<div style="position: absolute; left: 50%; margin-left: -400px; width: 800px; bottom: 50%; font-size: 80%; font-weight: bold">Estonian Resource Grammar.<br/>Project at the GF Summer School 2013</div>
<div style="position: absolute; left: 50%; margin-left: -400px; width: 800px; bottom: 25%; font-size: 45%">Inari Listenmaa, Kaarel Kaljurand</div>
<div style="position: absolute; left: 50%; margin-left: -400px; width: 800px; bottom: 15%; font-size: 45%; font-style: italic"></div>
<div style="position: absolute; left: 50%; margin-left: -300px; width: 600px; bottom: 6%; font-size: 40%">Third GF Summer School 2013, Frauenchiemsee, Bavaria</div>
<div style="position: absolute; left: 50%; margin-left: -300px; width: 600px; bottom: 0%; font-size: 40%">2013-08-30</div>
</h1>

---
# Estonian resource grammar

  - Estonian
    - spoken in Estonia by ~1 million people
    - (Balto-)Finnic subgroup of Uralic languages
    - related languages: Finnish (5M speakers), Võro (75k speakers) <!--, Karelian, Votic, Veps, ... -->
  - work on the Estonian RG started at GF Summer School 2011
    - modifying the Finnish RG
    - progress has been slow
  - project pages:
    - Estonian RG: <https://github.com/GF-Estonian/GF-Estonian>
    - PhrasebookEst: <https://github.com/Kaljurand/PhrasebookEst>

---
# Morphology

  - Nouns
    - 14 cases * 2 numbers
  - Verbs
    - Tense: present, imperfect
    - Mood: indicative, imperative, conditional, quotative
    - Voice: active, passive
    - Nominal forms: {_ma_ infinitive, _da_ infinitive, past participle} * cases ; present participle
  - Adjectives
    - Noun inflection + comparative and superlative

---
# Morpho(phono)logy   

  - Variable stress 
    - not shown in orthography 
    - kala ``['ka.la]`` vs. banaan [``ba.'naan]`` (mostly words of foreign origin)
  - No vowel harmony
  - 3-way quantity system
    - koli (I, _junk_), kooli (II, _school (gen)_), kooli (III, _school (part, illat)_)
    - link (nom), lingi (gen), linki (part)
  - Palatalization
    - palk (_salary_), pa`lk (_log_)

---
# Nouns

	!haskell
	param
	  Case = Nom | Gen | Part
         | Illat | Iness | Elat | Allat | Adess | Ablat
         | Transl | Ess | Termin | Abess | Comit;

	  NForm = NCase Number Case ;

  - started implementing the noun morphology based on "Heiki-Jaan Kaalep. Eesti käänamissüsteemi seaduspärasused" (HJK EKS)
  - 6 forms needed, others calculated from genitive
  - currently ignoring parallel forms
  - rules in HJK EKS depend on singular nominative, its stress, quantity, derivation from a verb, foreignness

---
# Smart paradigms

13 templates for creating 6 forms from 1 (sg nom)

	!haskell
	-- link -> link, lingi, linki, linki, linkide, linke
    hjk_type_VI_link x =
        let
            x_n : Str = weaker x
        in
        hjk_nForms6 x (x_n+"i") (x+"i") (x+"i") (x+"ide") (x+"e") ;



Mapping singular nominative to the templates

	/2 II V/               -> type 3
	/2 I V/, foreign       -> type 3
	/2 III V/              -> type 4a
	/3 CV[lmnr]/           -> type 6 seminar
	/e/, derived from verb -> type 7
	...

__TODO__: genitive form as an additional argument

	lakk, laka, lakka, lakka, lakkade, lakkasid
	lakk, laki, lakki, lakki, lakkide, lakkisid

---
# Adjectives

	!haskell
	param
	  AForm = AN NForm | AAdv ;

	oper
	  Adjective : Type = {s : Degree => AForm => Str} ;

  - derived from noun forms
  - comparative derived from genitive
  - superlative more complex but can be expressed also by _kõige_ + ``Comparative``
  - adverbial form derived from ablative


---
# Verbs
	!haskell
	param
        VForm = 
        Presn Number Person | Impf Number Person | Condit Number Person 
        | Imper Number | ImperP3 Number | ImperP1Pl | ImpNegPl 
        | PassPresn Bool | PassImpf Bool 
        | Inf InfForm | PresPart | PastPartAct AForm | PastPartPass AForm ;

        InfForm = 
        InfDa | InfDes | InfMa | InfMas | InfMast | InfMata | InfMaks ;

  - full conjugation tables from 4 forms (regular verbs) or 8 forms (25 irregular verbs) 
    - verbs _be_ and _go_ formed separately
    - for comparison: Finnish worst case 12 forms
  - smart paradigms for 1, (2,) 4 and 8 arguments currently
  - TODO: add quotative, rethink the nominal forms (Inf)
  
---
# Smart paradigms

  - 15 templates for creating 8 forms from 1 forms
  - 1-argument smart paradigms for some verbs
  - TODO better 1-arg paradigms, decide 2- and 3-arg paradigms
 
  
---
# Testing morphology

__TODO__

  - main questions:
    - percentage of words covered by the 1-arg smart paradigms?
    - types of remaining problems?
  - using Filosoft's morph. synthesizer as the gold standard
  - test vocabulary e.g. from the Estonian WordNet (44k words in 29k synsets)

---
# Syntax

  - (2 years old) copy of the Finnish RG
  - several changes
    - "-ko" particle -> "kas"
    - possessive endings -> "minu"/"tema"/"oma"
      - reflexive possessive _oma_ as a separate construction in ExtraEst
  - __TODO__
    - trennbare verben
    - also lacking from Finnish (Fin _ylläpitää ~ pidän yllä_; Est _aru saama ~ saan aru_)

---
# Testing syntax

  - developing PhrasebookEst in parallel
    - this has not highlighted any major problems
  - adding Estonian to ACE-in-GF
    - this has not highlighted any major problems

---
# Resources used

  - Noun morphology
    - Heiki-Jaan Kaalep. Eesti käänamissüsteemi seaduspärasused <http://kjk.eki.ee/ee/issues/2012/6/156>
  - Verb morphology
    - Eesti õigekeelsussõnaraamat (2006) classification system _tüüpsõnad_ <http://www.eki.ee/dict/qs/tyypsonad.html>
    - Eesti keele käsiraamat (2009) for internal paradigm building (``VForms -> Verb``) <http://www.eki.ee/books/ekk09/index.php?p=3&p1=5&id=227>
    - Estonian WordNet <http://www.cl.ut.ee/ressursid/teksaurus/>
  
---
# Future work

  - testing
  - cleanup
  - submission to the GF RGL
  - sharing of code with Finnish
  - Dict(Eng)Est, from WordNet?

---
# Täname!
